SystemOrganization addCategory: #'Pier-Exporter'!

PRVisitor subclass: #PRKernelExtractor
	instanceVariableNames: 'filesystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter'!

!PRKernelExtractor class methodsFor: 'accessing-defaults' stamp: 'DamienCassou 9/14/2010 11:19'!
defaultDirectory
	^ FSDiskFilesystem imageDirectory! !

!PRKernelExtractor class methodsFor: 'accessing-defaults' stamp: 'DamienCassou 9/14/2010 11:19'!
defaultKernel
	^ PRKernel instances anyOne! !

!PRKernelExtractor class methodsFor: 'actions' stamp: 'DamienCassou 9/14/2010 11:28'!
extractKernel
	^ (self new	setDirectory: self defaultDirectory)
		extractKernel: self defaultKernel! !

!PRKernelExtractor class methodsFor: 'actions' stamp: 'DamienCassou 9/14/2010 11:29'!
extractKernel: aKernel
	^ (self new setDirectory: self defaultDirectory)
		extractKernel: aKernel! !

!PRKernelExtractor class methodsFor: 'actions' stamp: 'DamienCassou 9/14/2010 11:29'!
extractKernel: aKernel to: anFSReference
	^ (self new	setDirectory: anFSReference)
		extractKernel: aKernel! !

!PRKernelExtractor class methodsFor: 'actions' stamp: 'DamienCassou 9/14/2010 11:29'!
extractKernelTo: anFSReference
	^ (self new	setDirectory: anFSReference)
		extractKernel: self defaultKernel! !

!PRKernelExtractor methodsFor: 'private' stamp: 'DamienCassou 9/14/2010 11:03'!
createDirectoryFor: aPRStructure
	filesystem := filesystem resolveString: aPRStructure name.
	filesystem ensureDirectory! !

!PRKernelExtractor methodsFor: 'initialization' stamp: 'DamienCassou 9/14/2010 11:04'!
extractKernel: aKernel
	filesystem := filesystem resolveString: 'pier-export'.
	filesystem ensureDirectory.
	aKernel root accept: self! !

!PRKernelExtractor methodsFor: 'private' stamp: 'DamienCassou 9/14/2010 11:02'!
extractStructureContentOf: aPRPage
	|file|
	file := filesystem resolveString: '_content.pr'.
	file fileStreamDo: [:st | PRWikiWriter write: aPRPage document to: st]! !

!PRKernelExtractor methodsFor: 'private' stamp: 'DamienCassou 9/14/2010 10:59'!
parentDirectory
	filesystem := filesystem parent! !

!PRKernelExtractor methodsFor: 'initialization' stamp: 'DamienCassou 9/14/2010 10:51'!
setDirectory: aFSReference
	filesystem := aFSReference ! !

!PRKernelExtractor methodsFor: 'visiting-structure' stamp: 'DamienCassou 9/14/2010 10:05'!
visitPage: aPRStructure
	self createDirectoryFor: aPRStructure.
	self extractStructureContentOf: aPRStructure.
	aPRStructure enumerator do: [:aChild | aChild accept: self].
	self parentDirectory! !

!PRKernelExtractor methodsFor: 'visiting-structure' stamp: 'DamienCassou 9/13/2010 22:59'!
visitStructure: aPRStructure
	self createDirectoryFor: aPRStructure.
	self extractStructureContentOf: aPRStructure.
	aPRStructure enumerator do: [:aChild | aChild accept: self].
	self parentDirectory! !
